<?php
namespace Bushelpowered\Api\Aggregator\Iam\V1\Response;
        
class StaffUserRoleBindingsResponse 
{
    /** @var string $id */
    public string $id;
    /** @var null|string $firstName The user's first name, some user's entire name may be loaded into their first name field.*/
    public ?string $firstName = null;
    /** @var null|string $lastName The user's last name. This will generally be available, though may be concatenated on the end of first name.*/
    public ?string $lastName = null;
    /** @var null|string $email The user's email.*/
    public ?string $email = null;
    /** @var \Bushelpowered\Api\Aggregator\Iam\V1\Response\StaffUserTenant[] $staffUserTenants */
    public array $staffUserTenants;
    /** @var \Bushelpowered\Api\Aggregator\Iam\V1\Response\StaffRoleBinding[] $staffRoleBindings */
    public array $staffRoleBindings;

    /**
     * @param  string  $id 
     * @param  null|string  $firstName The user's first name, some user's entire name may be loaded into their first name field.
     * @param  null|string  $lastName The user's last name. This will generally be available, though may be concatenated on the end of first name.
     * @param  null|string  $email The user's email.
     * @param  \Bushelpowered\Api\Aggregator\Iam\V1\Response\StaffUserTenant[]  $staffUserTenants 
     * @param  \Bushelpowered\Api\Aggregator\Iam\V1\Response\StaffRoleBinding[]  $staffRoleBindings 
     */
    public function __construct(string $id, ?string $firstName, ?string $lastName, ?string $email, array $staffUserTenants, array $staffRoleBindings)
    {
        $this->id = $id;
        $this->firstName = $firstName;
        $this->lastName = $lastName;
        $this->email = $email;
        $this->staffUserTenants = $staffUserTenants;
        $this->staffRoleBindings = $staffRoleBindings;
    }
    

}