<?php
namespace Bushelpowered\Api\Aggregator\Location\V1\Response;
        
class LocationResponse implements \Bushelpowered\Api\Aggregator\Location\V1\Response\HasLocationData, \Bushelpowered\Api\Common\HasSourceTimestamps, \Bushelpowered\Api\Common\HasTimestamps
{
    /** @var null|\Bushelpowered\Api\Platform\Location\V1\Model\FacilityStandard $parent */
    public ?\Bushelpowered\Api\Platform\Location\V1\Model\FacilityStandard $parent = null;
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $tenantId The tenant identifier.*/
    public string $tenantId;
    /** @var string $datasourceId The datasource identifier.*/
    public string $datasourceId;
    /** @var string $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.*/
    public string $integrationId;
    /** @var string $sourceId The source record identifier.*/
    public string $sourceId;
    /** @var null|string $sourceName The source record location name.*/
    public ?string $sourceName = null;
    /** @var null|string $internalName The internal location name.*/
    public ?string $internalName = null;
    /** @var null|string $publicName The public-facing location name.*/
    public ?string $publicName = null;
    /** @var null|string $physicalAddressLine1 The first line of the physical address.*/
    public ?string $physicalAddressLine1 = null;
    /** @var null|string $physicalAddressLine2 The second line of the physical address.*/
    public ?string $physicalAddressLine2 = null;
    /** @var null|string $physicalLocality The city or locality.*/
    public ?string $physicalLocality = null;
    /** @var null|string $physicalAdministrativeArea The state or region.*/
    public ?string $physicalAdministrativeArea = null;
    /** @var null|string $physicalPostalCode The postal or ZIP code.*/
    public ?string $physicalPostalCode = null;
    /** @var null|string $physicalCountryCode The ISO country code.*/
    public ?string $physicalCountryCode = null;
    /** @var null|float $latitude The latitude coordinate.*/
    public ?float $latitude = null;
    /** @var null|float $longitude The longitude coordinate.*/
    public ?float $longitude = null;
    /** @var string[]|null $businessType The list of business types for the location.  Expected options include Grain Delivery, Agronomy, Office, Plant, Seed and Feed*/
    public ?array $businessType = null;
    /** @var null|string $businessPhone The business phone number.*/
    public ?string $businessPhone = null;
    /** @var null|string $businessFax The business fax number.*/
    public ?string $businessFax = null;
    /** @var null|string $businessEmail The business email address.*/
    public ?string $businessEmail = null;
    /** @var null|string $businessWebsite The business website URL.*/
    public ?string $businessWebsite = null;
    /** @var null|int $centreId The location identifier in Centre.*/
    public ?int $centreId = null;
    /** @var int $companyId The company identifier in Centre.*/
    public int $companyId;
    /** @var string $companyIdRemoteId The global unique identifier of the remote record in Centre.*/
    public string $companyIdRemoteId;
    /** @var null|bool $hidden Whether the location is hidden in Centre.*/
    public ?bool $hidden = null;
    /** @var null|string $cashBidsHiddenAt When cash bids were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $cashBidsHiddenAt = null;
    /** @var null|string $pushNotificationsHiddenAt When push notifications were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $pushNotificationsHiddenAt = null;
    /** @var null|string $revision The data revision number in Centre.*/
    public ?string $revision = null;
    /** @var string $sourceCreatedAt Created date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceCreatedAt;
    /** @var string $sourceUpdatedAt Updated date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceUpdatedAt;
    /** @var null|string $sourceDeletedAt Deleted date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourceDeletedAt = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  null|\Bushelpowered\Api\Platform\Location\V1\Model\FacilityStandard  $parent 
     * @param  string  $id The primary unique identifier.
     * @param  string  $tenantId The tenant identifier.
     * @param  string  $datasourceId The datasource identifier.
     * @param  string  $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     * @param  string  $sourceId The source record identifier.
     * @param  null|string  $sourceName The source record location name.
     * @param  null|string  $internalName The internal location name.
     * @param  null|string  $publicName The public-facing location name.
     * @param  null|string  $physicalAddressLine1 The first line of the physical address.
     * @param  null|string  $physicalAddressLine2 The second line of the physical address.
     * @param  null|string  $physicalLocality The city or locality.
     * @param  null|string  $physicalAdministrativeArea The state or region.
     * @param  null|string  $physicalPostalCode The postal or ZIP code.
     * @param  null|string  $physicalCountryCode The ISO country code.
     * @param  null|float  $latitude The latitude coordinate.
     * @param  null|float  $longitude The longitude coordinate.
     * @param  string[]|null  $businessType The list of business types for the location.  Expected options include Grain Delivery, Agronomy, Office, Plant, Seed and Feed
     * @param  null|string  $businessPhone The business phone number.
     * @param  null|string  $businessFax The business fax number.
     * @param  null|string  $businessEmail The business email address.
     * @param  null|string  $businessWebsite The business website URL.
     * @param  null|int  $centreId The location identifier in Centre.
     * @param  int  $companyId The company identifier in Centre.
     * @param  string  $companyIdRemoteId The global unique identifier of the remote record in Centre.
     * @param  null|bool  $hidden Whether the location is hidden in Centre.
     * @param  null|string  $cashBidsHiddenAt When cash bids were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $pushNotificationsHiddenAt When push notifications were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $revision The data revision number in Centre.
     * @param  string  $sourceCreatedAt Created date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $sourceUpdatedAt Updated date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $sourceDeletedAt Deleted date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(?\Bushelpowered\Api\Platform\Location\V1\Model\FacilityStandard $parent, string $id, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceName, ?string $internalName, ?string $publicName, ?string $physicalAddressLine1, ?string $physicalAddressLine2, ?string $physicalLocality, ?string $physicalAdministrativeArea, ?string $physicalPostalCode, ?string $physicalCountryCode, ?float $latitude, ?float $longitude, ?array $businessType, ?string $businessPhone, ?string $businessFax, ?string $businessEmail, ?string $businessWebsite, ?int $centreId, int $companyId, string $companyIdRemoteId, ?bool $hidden, ?string $cashBidsHiddenAt, ?string $pushNotificationsHiddenAt, ?string $revision, string $sourceCreatedAt, string $sourceUpdatedAt, ?string $sourceDeletedAt, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->parent = $parent;
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceName = $sourceName;
        $this->internalName = $internalName;
        $this->publicName = $publicName;
        $this->physicalAddressLine1 = $physicalAddressLine1;
        $this->physicalAddressLine2 = $physicalAddressLine2;
        $this->physicalLocality = $physicalLocality;
        $this->physicalAdministrativeArea = $physicalAdministrativeArea;
        $this->physicalPostalCode = $physicalPostalCode;
        $this->physicalCountryCode = $physicalCountryCode;
        $this->latitude = $latitude;
        $this->longitude = $longitude;
        $this->businessType = $businessType;
        $this->businessPhone = $businessPhone;
        $this->businessFax = $businessFax;
        $this->businessEmail = $businessEmail;
        $this->businessWebsite = $businessWebsite;
        $this->centreId = $centreId;
        $this->companyId = $companyId;
        $this->companyIdRemoteId = $companyIdRemoteId;
        $this->hidden = $hidden;
        $this->cashBidsHiddenAt = $cashBidsHiddenAt;
        $this->pushNotificationsHiddenAt = $pushNotificationsHiddenAt;
        $this->revision = $revision;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string The primary unique identifier.
     */
    public function getId(): string
    {
        return $this->id;
    }
    /**
     * @return string The tenant identifier.
     */
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    /**
     * @return string The datasource identifier.
     */
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    /**
     * @return string The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     */
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    /**
     * @return string The source record identifier.
     */
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    /**
     * @return null|string The source record location name.
     */
    public function getSourceName(): ?string
    {
        return $this->sourceName;
    }
    /**
     * @return null|string The internal location name.
     */
    public function getInternalName(): ?string
    {
        return $this->internalName;
    }
    /**
     * @return null|string The public-facing location name.
     */
    public function getPublicName(): ?string
    {
        return $this->publicName;
    }
    /**
     * @return null|string The first line of the physical address.
     */
    public function getPhysicalAddressLine1(): ?string
    {
        return $this->physicalAddressLine1;
    }
    /**
     * @return null|string The second line of the physical address.
     */
    public function getPhysicalAddressLine2(): ?string
    {
        return $this->physicalAddressLine2;
    }
    /**
     * @return null|string The city or locality.
     */
    public function getPhysicalLocality(): ?string
    {
        return $this->physicalLocality;
    }
    /**
     * @return null|string The state or region.
     */
    public function getPhysicalAdministrativeArea(): ?string
    {
        return $this->physicalAdministrativeArea;
    }
    /**
     * @return null|string The postal or ZIP code.
     */
    public function getPhysicalPostalCode(): ?string
    {
        return $this->physicalPostalCode;
    }
    /**
     * @return null|string The ISO country code.
     */
    public function getPhysicalCountryCode(): ?string
    {
        return $this->physicalCountryCode;
    }
    /**
     * @return null|float The latitude coordinate.
     */
    public function getLatitude(): ?float
    {
        return $this->latitude;
    }
    /**
     * @return null|float The longitude coordinate.
     */
    public function getLongitude(): ?float
    {
        return $this->longitude;
    }
    /**
     * @return string[]|null The list of business types for the location.  Expected options include Grain Delivery, Agronomy, Office, Plant, Seed and Feed
     */
    public function getBusinessType(): ?array
    {
        return $this->businessType;
    }
    /**
     * @return null|string The business phone number.
     */
    public function getBusinessPhone(): ?string
    {
        return $this->businessPhone;
    }
    /**
     * @return null|string The business fax number.
     */
    public function getBusinessFax(): ?string
    {
        return $this->businessFax;
    }
    /**
     * @return null|string The business email address.
     */
    public function getBusinessEmail(): ?string
    {
        return $this->businessEmail;
    }
    /**
     * @return null|string The business website URL.
     */
    public function getBusinessWebsite(): ?string
    {
        return $this->businessWebsite;
    }
    /**
     * @return null|int The location identifier in Centre.
     */
    public function getCentreId(): ?int
    {
        return $this->centreId;
    }
    /**
     * @return int The company identifier in Centre.
     */
    public function getCompanyId(): int
    {
        return $this->companyId;
    }
    /**
     * @return string The global unique identifier of the remote record in Centre.
     */
    public function getCompanyIdRemoteId(): string
    {
        return $this->companyIdRemoteId;
    }
    /**
     * @return null|bool Whether the location is hidden in Centre.
     */
    public function getHidden(): ?bool
    {
        return $this->hidden;
    }
    /**
     * @return null|string When cash bids were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCashBidsHiddenAt(): ?string
    {
        return $this->cashBidsHiddenAt;
    }
    /**
     * @return null|string When push notifications were hidden in Centre. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getPushNotificationsHiddenAt(): ?string
    {
        return $this->pushNotificationsHiddenAt;
    }
    /**
     * @return null|string The data revision number in Centre.
     */
    public function getRevision(): ?string
    {
        return $this->revision;
    }
    /**
     * @return string Created date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceCreatedAt(): string
    {
        return $this->sourceCreatedAt;
    }
    /**
     * @return string Updated date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceUpdatedAt(): string
    {
        return $this->sourceUpdatedAt;
    }
    /**
     * @return null|string Deleted date-time from data source. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceDeletedAt(): ?string
    {
        return $this->sourceDeletedAt;
    }
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}