<?php
namespace Bushelpowered\Api\Crm\V1\Response;
        
class CustomerSearchResponse 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $name The name of the customer, editable*/
    public string $name;
    /** @var string[] $accountIds The ERP Account ids associated with the customer*/
    public array $accountIds;
    /** @var string[] $phones The phone numbers associated with the customer's identifiers*/
    public array $phones;
    /** @var string[] $emails The email addresses associated with the customer's identifiers*/
    public array $emails;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $name The name of the customer, editable
     * @param  string[]  $accountIds The ERP Account ids associated with the customer
     * @param  string[]  $phones The phone numbers associated with the customer's identifiers
     * @param  string[]  $emails The email addresses associated with the customer's identifiers
     */
    public function __construct(string $id, string $name, array $accountIds, array $phones, array $emails)
    {
        $this->id = $id;
        $this->name = $name;
        $this->accountIds = $accountIds;
        $this->phones = $phones;
        $this->emails = $emails;
    }
    

}