<?php
namespace Bushelpowered\Api\Fulfillment\Ticket\V1\Response;
        
class TicketResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var int $id The id of the ticket*/
    public int $id;
    /** @var string $remoteId The id of ticket in the remote system*/
    public string $remoteId;
    /** @var null|string $displayId The display id of ticket*/
    public ?string $displayId = null;
    /** @var null|\Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account */
    public ?\Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account = null;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location;
    /** @var null|float $dockDollars The amount of money docked from the ticket, given in the local currency.*/
    public ?float $dockDollars = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[] $remarks */
    public array $remarks;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\AddendumResponse[] $addendum */
    public array $addendum;
    /** @var null|string $grader */
    public ?string $grader = null;
    /** @var null|string $weighMaster */
    public ?string $weighMaster = null;
    /** @var null|string $truckName */
    public ?string $truckName = null;
    /** @var null|string $truckLicense */
    public ?string $truckLicense = null;
    /** @var null|string $truckDriver */
    public ?string $truckDriver = null;
    /** @var null|string $weighInAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $weighInAt = null;
    /** @var null|string $weighOutAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $weighOutAt = null;
    /** @var null|string $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteCreatedAt = null;
    /** @var null|string $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteUpdatedAt = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\SplitResponse[] $splits Used to track how much of the ticket was assigned to each account.*/
    public array $splits;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity;
    /** @var null|string $amountsUom */
    public ?string $amountsUom = null;
    /** @var null|string $weightsUom */
    public ?string $weightsUom = null;
    /** @var null|float $grossAmount */
    public ?float $grossAmount = null;
    /** @var null|float $grossWeight */
    public ?float $grossWeight = null;
    /** @var null|float $netAmount */
    public ?float $netAmount = null;
    /** @var null|float $netWeight */
    public ?float $netWeight = null;
    /** @var null|float $shrinkAmount */
    public ?float $shrinkAmount = null;
    /** @var null|float $shrinkWeight */
    public ?float $shrinkWeight = null;
    /** @var null|float $dockAmount */
    public ?float $dockAmount = null;
    /** @var null|float $dockWeight */
    public ?float $dockWeight = null;
    /** @var null|float $tareWeight */
    public ?float $tareWeight = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\ExceededThresholdResponse[] $exceededThresholds */
    public array $exceededThresholds;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  int  $id The id of the ticket
     * @param  string  $remoteId The id of ticket in the remote system
     * @param  null|string  $displayId The display id of ticket
     * @param  null|\Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse  $account 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse  $company 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse  $location 
     * @param  null|float  $dockDollars The amount of money docked from the ticket, given in the local currency.
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[]  $remarks 
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\AddendumResponse[]  $addendum 
     * @param  null|string  $grader 
     * @param  null|string  $weighMaster 
     * @param  null|string  $truckName 
     * @param  null|string  $truckLicense 
     * @param  null|string  $truckDriver 
     * @param  null|string  $weighInAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $weighOutAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\SplitResponse[]  $splits Used to track how much of the ticket was assigned to each account.
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse  $commodity 
     * @param  null|string  $amountsUom 
     * @param  null|string  $weightsUom 
     * @param  null|float  $grossAmount 
     * @param  null|float  $grossWeight 
     * @param  null|float  $netAmount 
     * @param  null|float  $netWeight 
     * @param  null|float  $shrinkAmount 
     * @param  null|float  $shrinkWeight 
     * @param  null|float  $dockAmount 
     * @param  null|float  $dockWeight 
     * @param  null|float  $tareWeight 
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\ExceededThresholdResponse[]  $exceededThresholds 
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(int $id, string $remoteId, ?string $displayId, ?\Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location, ?float $dockDollars, array $remarks, array $addendum, ?string $grader, ?string $weighMaster, ?string $truckName, ?string $truckLicense, ?string $truckDriver, ?string $weighInAt, ?string $weighOutAt, ?string $remoteCreatedAt, ?string $remoteUpdatedAt, array $splits, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity, ?string $amountsUom, ?string $weightsUom, ?float $grossAmount, ?float $grossWeight, ?float $netAmount, ?float $netWeight, ?float $shrinkAmount, ?float $shrinkWeight, ?float $dockAmount, ?float $dockWeight, ?float $tareWeight, array $exceededThresholds, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->account = $account;
        $this->company = $company;
        $this->location = $location;
        $this->dockDollars = $dockDollars;
        $this->remarks = $remarks;
        $this->addendum = $addendum;
        $this->grader = $grader;
        $this->weighMaster = $weighMaster;
        $this->truckName = $truckName;
        $this->truckLicense = $truckLicense;
        $this->truckDriver = $truckDriver;
        $this->weighInAt = $weighInAt;
        $this->weighOutAt = $weighOutAt;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->splits = $splits;
        $this->commodity = $commodity;
        $this->amountsUom = $amountsUom;
        $this->weightsUom = $weightsUom;
        $this->grossAmount = $grossAmount;
        $this->grossWeight = $grossWeight;
        $this->netAmount = $netAmount;
        $this->netWeight = $netWeight;
        $this->shrinkAmount = $shrinkAmount;
        $this->shrinkWeight = $shrinkWeight;
        $this->dockAmount = $dockAmount;
        $this->dockWeight = $dockWeight;
        $this->tareWeight = $tareWeight;
        $this->exceededThresholds = $exceededThresholds;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}