<?php
namespace Bushelpowered\Api\Payments\V1\Event;
        
class PaymentEvent implements \Bushelpowered\Api\Common\Event\Event, \Bushelpowered\Api\Common\Event\StandardEvent
{
    /** @var \Bushelpowered\Api\Payments\V1\Model\PaymentStandard $data */
    public \Bushelpowered\Api\Payments\V1\Model\PaymentStandard $data;
    /** @var string $idempotencyKey A key to uniquely identify this event.*/
    public string $idempotencyKey;
    /** @var string $eventCreationTime The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $eventCreationTime;
    /** @var null|string $tenantId The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.*/
    public ?string $tenantId = null;

    /**
     * @param  \Bushelpowered\Api\Payments\V1\Model\PaymentStandard  $data 
     * @param  string  $idempotencyKey A key to uniquely identify this event.
     * @param  string  $eventCreationTime The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $tenantId The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.
     */
    public function __construct(\Bushelpowered\Api\Payments\V1\Model\PaymentStandard $data, string $idempotencyKey, string $eventCreationTime, ?string $tenantId)
    {
        $this->data = $data;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    /**
     * @return \Bushelpowered\Api\Payments\V1\Model\PaymentStandard 
     */
    public function getData(): \Bushelpowered\Api\Payments\V1\Model\PaymentStandard
    {
        return $this->data;
    }
    /**
     * @return string A key to uniquely identify this event.
     */
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    /**
     * @return string The time the event was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getEventCreationTime(): string
    {
        return $this->eventCreationTime;
    }
    /**
     * @return null|string The tenant that this event belongs to/was emitted for. Null if an event is not for a specific tenant.
     */
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}