<?php

namespace Bushelpowered\Api\Platform\File\V1\Request;

class GetFilesRequestOptions
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'includeFileUrls' => '\Bushelpowered\Api\Platform\File\V1\Common\IncludeFileUrlsOption',
        'includeAttachments' => '\Bushelpowered\Api\Platform\File\V1\Common\IncludeAttachmentsOption',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function IncludeFileUrls(\Bushelpowered\Api\Platform\File\V1\Common\IncludeFileUrlsOption $data): GetFilesRequestOptions
    {
        return new GetFilesRequestOptions('includeFileUrls', $data);
    }
    public static function IncludeAttachments(\Bushelpowered\Api\Platform\File\V1\Common\IncludeAttachmentsOption $data): GetFilesRequestOptions
    {
        return new GetFilesRequestOptions('includeAttachments', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    