<?php

namespace Bushelpowered\Api\Platform\Message\V1\Request;

class MessageTargetData
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'userData' => '\Bushelpowered\Api\Platform\Message\V1\Request\UserTargetData',
        'directIdentifierData' => '\Bushelpowered\Api\Platform\Message\V1\Request\DirectIdentifierTargetData',
        'permissionData' => '\Bushelpowered\Api\Platform\Message\V1\Request\PermissionTargetData',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function UserData(\Bushelpowered\Api\Platform\Message\V1\Request\UserTargetData $data): MessageTargetData
    {
        return new MessageTargetData('userData', $data);
    }
    public static function DirectIdentifierData(\Bushelpowered\Api\Platform\Message\V1\Request\DirectIdentifierTargetData $data): MessageTargetData
    {
        return new MessageTargetData('directIdentifierData', $data);
    }
    public static function PermissionData(\Bushelpowered\Api\Platform\Message\V1\Request\PermissionTargetData $data): MessageTargetData
    {
        return new MessageTargetData('permissionData', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    