<?php
namespace Bushelpowered\Api\Quoting\V1\Request;
        
class StaffCreateQuoteNotificationRequest 
{
    /** @var string $quoteId The id of the quote to send a notification for*/
    public string $quoteId;
    /** @var \Bushelpowered\Api\Quoting\V1\Enums\DeliveryMethod $deliveryMethod */
    public \Bushelpowered\Api\Quoting\V1\Enums\DeliveryMethod $deliveryMethod;
    /** @var string[]|null $emails The list of emails to send the notification to, required if delivery method is email*/
    public ?array $emails = null;

    /**
     * @param  string  $quoteId The id of the quote to send a notification for
     * @param  \Bushelpowered\Api\Quoting\V1\Enums\DeliveryMethod  $deliveryMethod 
     * @param  string[]|null  $emails The list of emails to send the notification to, required if delivery method is email
     */
    public function __construct(string $quoteId, \Bushelpowered\Api\Quoting\V1\Enums\DeliveryMethod $deliveryMethod, ?array $emails)
    {
        $this->quoteId = $quoteId;
        $this->deliveryMethod = $deliveryMethod;
        $this->emails = $emails;
    }
    

}