<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Response;
        
class CashBidGroupOverrideResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id The unique identifier for a specific CashBidGroupOverride.*/
    public string $id;
    /** @var string $companyId The unique identifier for a specific Company related to the CashBidGroupOverride.*/
    public string $companyId;
    /** @var string $cqgSymbolId The identifier for the CQG symbol.*/
    public string $cqgSymbolId;
    /** @var null|string $commodityName The name for the commodity.*/
    public ?string $commodityName = null;
    /** @var null|string $commodityProductName The name for the commodity product.*/
    public ?string $commodityProductName = null;
    /** @var null|string $tickSize The tick size for the CashBidGroupOverride.*/
    public ?string $tickSize = null;
    /** @var bool $display The status indicating whether or not the CashBidGroup is displayed.*/
    public bool $display;
    /** @var bool $ignoreUnitConversion The status indicating whether we should ignore unit conversion.*/
    public bool $ignoreUnitConversion;
    /** @var int $sortOrder The order in which the CashBidGroup should be displayed in the API response.*/
    public int $sortOrder;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The unique identifier for a specific CashBidGroupOverride.
     * @param  string  $companyId The unique identifier for a specific Company related to the CashBidGroupOverride.
     * @param  string  $cqgSymbolId The identifier for the CQG symbol.
     * @param  null|string  $commodityName The name for the commodity.
     * @param  null|string  $commodityProductName The name for the commodity product.
     * @param  null|string  $tickSize The tick size for the CashBidGroupOverride.
     * @param  bool  $display The status indicating whether or not the CashBidGroup is displayed.
     * @param  bool  $ignoreUnitConversion The status indicating whether we should ignore unit conversion.
     * @param  int  $sortOrder The order in which the CashBidGroup should be displayed in the API response.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $companyId, string $cqgSymbolId, ?string $commodityName, ?string $commodityProductName, ?string $tickSize, bool $display, bool $ignoreUnitConversion, int $sortOrder, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->companyId = $companyId;
        $this->cqgSymbolId = $cqgSymbolId;
        $this->commodityName = $commodityName;
        $this->commodityProductName = $commodityProductName;
        $this->tickSize = $tickSize;
        $this->display = $display;
        $this->ignoreUnitConversion = $ignoreUnitConversion;
        $this->sortOrder = $sortOrder;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}