<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Request;
        
class ESignSignedRequest 
{
    /** @var string $datasourceId The id of the datasource this record came from.*/
    public string $datasourceId;
    /** @var string $tenantId The id of the tenant this record belongs to.*/
    public string $tenantId;
    /** @var string $contractSourceId The source record identifier.*/
    public string $contractSourceId;
    /** @var string $contractSourceDisplayId The source record display identifier. Usually a grower-friendly, non-unique identifier.*/
    public string $contractSourceDisplayId;
    /** @var string $contractSourceCustomerId The source customer record identifier.*/
    public string $contractSourceCustomerId;
    /** @var string $contractSourceCommodityId The source commodity record identifier.*/
    public string $contractSourceCommodityId;
    /** @var string $email eSign document email.*/
    public string $email;
    /** @var string $message eSign document email message.*/
    public string $message;
    /** @var string $subject eSign document email subject.*/
    public string $subject;
    /** @var string $title eSign document email title.*/
    public string $title;
    /** @var bool $hasError Boolean flag indicating whether there was an error with this document.*/
    public bool $hasError;
    /** @var bool $isTest Boolean flag indicating whether this document is a test.*/
    public bool $isTest;
    /** @var null|string $archivedAt The datetime for when the document was archived. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $archivedAt = null;
    /** @var null|string $completedAt The datetime for when the document was completed. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $completedAt = null;
    /** @var string $createdAt The datetime for when the document was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var null|string $declinedAt The datetime for when the document was declined. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $declinedAt = null;
    /** @var null|string $invalidAt The datetime for when the document was marked invalid. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $invalidAt = null;
    /** @var null|string $pendingAt The datetime for when the document was sent. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $pendingAt = null;

    /**
     * @param  string  $datasourceId The id of the datasource this record came from.
     * @param  string  $tenantId The id of the tenant this record belongs to.
     * @param  string  $contractSourceId The source record identifier.
     * @param  string  $contractSourceDisplayId The source record display identifier. Usually a grower-friendly, non-unique identifier.
     * @param  string  $contractSourceCustomerId The source customer record identifier.
     * @param  string  $contractSourceCommodityId The source commodity record identifier.
     * @param  string  $email eSign document email.
     * @param  string  $message eSign document email message.
     * @param  string  $subject eSign document email subject.
     * @param  string  $title eSign document email title.
     * @param  bool  $hasError Boolean flag indicating whether there was an error with this document.
     * @param  bool  $isTest Boolean flag indicating whether this document is a test.
     * @param  null|string  $archivedAt The datetime for when the document was archived. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $completedAt The datetime for when the document was completed. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt The datetime for when the document was created. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $declinedAt The datetime for when the document was declined. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $invalidAt The datetime for when the document was marked invalid. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $pendingAt The datetime for when the document was sent. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $datasourceId, string $tenantId, string $contractSourceId, string $contractSourceDisplayId, string $contractSourceCustomerId, string $contractSourceCommodityId, string $email, string $message, string $subject, string $title, bool $hasError, bool $isTest, ?string $archivedAt, ?string $completedAt, string $createdAt, ?string $declinedAt, ?string $invalidAt, ?string $pendingAt)
    {
        $this->datasourceId = $datasourceId;
        $this->tenantId = $tenantId;
        $this->contractSourceId = $contractSourceId;
        $this->contractSourceDisplayId = $contractSourceDisplayId;
        $this->contractSourceCustomerId = $contractSourceCustomerId;
        $this->contractSourceCommodityId = $contractSourceCommodityId;
        $this->email = $email;
        $this->message = $message;
        $this->subject = $subject;
        $this->title = $title;
        $this->hasError = $hasError;
        $this->isTest = $isTest;
        $this->archivedAt = $archivedAt;
        $this->completedAt = $completedAt;
        $this->createdAt = $createdAt;
        $this->declinedAt = $declinedAt;
        $this->invalidAt = $invalidAt;
        $this->pendingAt = $pendingAt;
    }
    

}